type TApplicationPageTitleProps = {
    /**
     * Prepend additional title parts to the default page title.
     * The parts are concatenated with a `-` separator and might be truncated
     * in the middle if each one exceeds 24 characters length.
     *
     * The default page title has always the format:
     *   <application_identifier> - <project_key> - Merchant Center
     *
     * Overwriting the default page title is recommended in detail pages
     * where there is a human-readable resource identifier, for example a product name.
     *
     * @example
     *
     * <ApplicationPageTitle additionalParts={['T-Shirt red']} />
     * // T-Shirt red - Products - my-shop - Merchant Center
     */
    additionalParts?: string[];
};
declare const ApplicationPageTitle: {
    ({ additionalParts, }: TApplicationPageTitleProps): null;
    displayName: string;
};
export default ApplicationPageTitle;
