import { JSX, type ReactNode, type SyntheticEvent } from 'react';
import type { TFlags } from '@flopflip/types';
import type { TAsyncLocaleDataProps } from '@commercetools-frontend/i18n';
type TApplicationShellAuthenticationProps = {
    featureFlags?: TFlags;
    defaultFeatureFlags?: TFlags;
    applicationMessages: TAsyncLocaleDataProps['applicationMessages'];
    onMenuItemClick?: (event: SyntheticEvent<HTMLAnchorElement>) => void;
    disableRoutePermissionCheck?: boolean;
    render?: () => JSX.Element;
    children?: ReactNode;
};
export declare const MainContainer: import("@emotion/styled").StyledComponent<{
    theme?: import("@emotion/react").Theme | undefined;
    as?: import("react").ElementType<any, keyof JSX.IntrinsicElements> | undefined;
}, import("react").DetailedHTMLProps<import("react").HTMLAttributes<HTMLElement>, HTMLElement>, {}>;
/**
 * This component is rendered whenever the user is considered "authenticated"
 * and contains the "restricted" application part.
 */
export declare const ApplicationShellAuthenticated: {
    (props: TApplicationShellAuthenticationProps): import("@emotion/react/jsx-runtime").JSX.Element;
    displayName: string;
};
export default ApplicationShellAuthenticated;
