import { JSX } from 'react';
import { ApolloClient, type NormalizedCacheObject } from '@apollo/client';
import { type TApplicationContext } from '@commercetools-frontend/application-shell-connectors';
import type { TAsyncLocaleDataProps } from '@commercetools-frontend/i18n';
type TApplicationShellProviderProps = {
    apolloClient?: ApolloClient<NormalizedCacheObject>;
    environment: TApplicationContext<{}>['environment'];
    applicationMessages: TAsyncLocaleDataProps['applicationMessages'];
    children: (args: {
        isAuthenticated: boolean;
    }) => JSX.Element;
};
declare const ApplicationShellProvider: {
    (props: TApplicationShellProviderProps): import("@emotion/react/jsx-runtime").JSX.Element;
    displayName: string;
};
export default ApplicationShellProvider;
