import type { ReactNode } from 'react';
import { ApolloClient, type NormalizedCacheObject } from '@apollo/client';
import type { RenderResult } from '@testing-library/react';
import { type TProviderProps } from '@commercetools-frontend/application-shell-connectors';
import { type CustomViewData } from '@commercetools-frontend/constants';
type TRenderCustomViewParams = {
    locale: string;
    projectKey?: string;
    projectAllAppliedPermissions?: {
        name: string;
        value: boolean;
    }[];
    customViewHostUrl?: string;
    customViewConfig?: Partial<CustomViewData>;
    apolloClient?: ApolloClient<NormalizedCacheObject>;
    environment?: Partial<TProviderProps<{}>['environment']>;
    user?: Partial<TProviderProps<{}>['user']>;
    children: ReactNode;
};
export declare const renderCustomView: (props: TRenderCustomViewParams) => RenderResult;
export {};
